package MakeWorld::Mogrify::Copy;

use strict;
use warnings;

use File::Copy::Recursive qw[ rcopy ];

use MakeWorld::Global;
use MakeWorld::Check qw[ check %BOOLEAN ];
use MakeWorld::Run;
use MakeWorld::Log;

################################################################################
# execute a command

sub verify {

    my ( $class, $opts, $need_hook ) = @_;

    return check( {
		   arg => { required => 1, default => [] },
		   dst => { required => 1 },
		   hook => { required => $need_hook },
		  }, $opts
		);
}


sub mogrify
{
    my ( $class, $pkg, $opts ) = @_;

    my $guard = log_pfx( '<copy>' );

    log_notice( $opts->{arg}, $opts->{dst} );

    foreach my $file ( @{ $opts->{arg} } )
    {
	log_info( $file );

	rcopy( $file, $opts->{dst} )
	  or log_fatal( "error copying $file to $opts->{dst}: $!\n" )
    }

    return;
}

1;
