package MakeWorld::Mogrify::MkPath;

use strict;
use warnings;

use File::Path qw[ make_path ];

use MakeWorld::Global;
use MakeWorld::Check qw[ check %BOOLEAN ];
use MakeWorld::Run;
use MakeWorld::Log;

################################################################################
# execute a command

sub verify {

    my ( $class, $opts, $need_hook ) = @_;

    return check( {
		   arg => { required => 1, default => [] },
		   hook => { required => $need_hook },
		  }, $opts
		);
}


sub mogrify
{
    my ( $class, $pkg, $opts ) = @_;

    my $guard = log_pfx( '<mkpath>' );

    log_info( $opts->{arg} );

    my $errors;
    make_path( @{ $opts->{arg} }, { error => \$errors } );

    log_fatal( map { @_ = %$_; "$_->[0]: $_->[1]\n" } @$errors )
      if @$errors;

    return;
}

1;
