package MakeWorld::Utils;

use strict;
use warnings;

use File::Spec::Functions qw[ catfile splitpath ];

use base 'Exporter';

use Module::Pluggable require => 1;
use Module::Load qw[ load ];
use MakeWorld::Global;

our @EXPORT_OK =
  qw[
	find_exe
	find_plugins
   ];


sub find_exe
{
    my ( $exe ) = @_;

    my $dirs = ( splitpath( $exe ) )[1];
    my $file;

    # if a leading path was specified, use that directly
    if ( $dirs ne '' )
    {
	$file = $exe if  -f $exe && -x _;
    }

    # not absolute; find it
    else
    {
	( $file ) = grep { -f $_ && -x _}
	  map { glob(catfile($_,$exe)) }
	    @{$Opt->srcdir}, split(':', $ENV{PATH} ), '.';
    }

    die( "unable to find executable command: $exe \n" )
	unless $file;

    return $file;
}



sub find_plugins {

    my ( $pkg, $plugins, $map ) = @_;

    __PACKAGE__->search_path( new => $pkg );

    @{$plugins} = __PACKAGE__->plugins();
    %{$map}     = map { my $module = $_;
		    $module =~ s/^.*:://;
		    ( lc($module) => $_ ) } @{$plugins};

    return;
}


1;
